
class TokaEfekti
{
  int unit = 50;
  float scrollX;
  int count;
  Module[] mods;
  PFont font;


  TokaEfekti() {
  }


  void setup() {
    noStroke();
    int wideCount = width / unit;
    int highCount = height / unit;
    scrollX = width - 60;
    count = wideCount * highCount;
    mods = new Module[count];
    font = loadFont("ARDESTINE-48.vlw"); // Vaihda takas haluamaksesi fontiksi jota mulla ei ollut "ARDESTINE-48.vlw"
  
    int index = 0;
    for (int y = 0; y < highCount; y++) {
      for (int x = 0; x < wideCount; x++) {
        mods[index++] = new Module(x*unit, y*unit, unit/2, unit/2, random(0.5, 0.8), unit);
      }
    }
  }


  void draw(float deltaSeconds, int deltaMillis, int partMillis, int fullMillis) {
    textFont(font, 40);
    background(0);
    for (int i = 0; i < count; i++) {
      mods[i].update();
      if (partMillis < 19000)   mods[i].draw();
    }

   fill(0, 0, 0);
   text ("DemoPart aika on: " +partMillis, 10, 50, 100);
  
if (partMillis > 3000 && partMillis < 6000) text ("Owlification presents Hello World", width/2 - 300, height/2, 100);
if (partMillis > 5000 && partMillis < 8000) text ("At Stream 10", width/2, height/2+200, 100);
if (partMillis > 7000 && partMillis < 10000) text ("code by sanni and zov", width/2 - 400, 200, 100); 
if (partMillis > 9000 && partMillis < 12000) text ("music by zov", width/2 - 400, height/2+200, 100); 
if (partMillis > 11000 && partMillis < 17000) text ("greetings to", width/2, height/2, 100); 
if (partMillis > 13000 && partMillis < 17000) text ("PwP", width/2 - 400, height/2+200, 100);
if (partMillis > 13500 && partMillis < 17000) text ("ISO", width/2 - 100, height/2+200, 100); 
if (partMillis > 14000 && partMillis < 17000) text ("trilobit", width/2 + 200, height/2+200, 100);
   }
   //else scrollX = width;
  }







class Module
{
  int xOffset;
  int yOffset;
  float x, y;
  int unit;
  int xDirection = 1;
  int yDirection = 1;
  float speed; 
  float r;
  float g;
  float b;
  float i;

  
  // Contructor
  Module(int xOffsetTemp, int yOffsetTemp, int xTemp, int yTemp, float speedTemp, int tempUnit) {
    xOffset = xOffsetTemp;
    yOffset = yOffsetTemp;
    x = xTemp;
    y = yTemp;
    speed = 0;
    unit = tempUnit;
  }

  
  // Custom method for updating the variables
  void update() {
    x = x + (speed * xDirection);
    if (x >= unit || x <= 0) {
      xDirection *= -1;
      x = x + (1 * xDirection);
      y = y + (1 * yDirection);
    }
    if (y >= unit || y <= 0) {
      yDirection *= -1;
      y = y + (1 * yDirection);
    }
  }

  
  // Custom method for drawing the object
  void draw() {
    noFill();
    r = 1;
    g = 2;
    b = 3;
    i = 30;
    ellipse(xOffset + x, yOffset + y, 6*millis()*0.003, 6*millis()*0.003);
    r = abs(i+millis()*0.001)+40;
    g = abs(i+millis()*0.001)+200; 
    b = abs(i+millis()*0.001)+40;
      stroke(r,g,b,i);
      strokeWeight(30);
  }
}

